Index: apache-tomcat-9.0.33-src/test/org/apache/coyote/http2/Http2TestBase.java
===================================================================
--- apache-tomcat-9.0.33-src.orig/test/org/apache/coyote/http2/Http2TestBase.java
+++ apache-tomcat-9.0.33-src/test/org/apache/coyote/http2/Http2TestBase.java
@@ -23,6 +23,7 @@ import java.io.InputStream;
 import java.io.OutputStream;
 import java.net.Socket;
 import java.net.SocketException;
+import java.nio.Buffer;
 import java.nio.ByteBuffer;
 import java.nio.charset.StandardCharsets;
 import java.util.ArrayList;
@@ -222,7 +223,7 @@ public abstract class Http2TestBase exte
         if (padding != null) {
             headersPayload.put(padding);
         }
-        headersPayload.flip();
+        ((Buffer)headersPayload).flip();
 
         ByteUtil.setThreeBytes(frameHeader, 0, headersPayload.limit());
         frameHeader[3] = FrameType.HEADERS.getIdByte();
@@ -255,7 +256,7 @@ public abstract class Http2TestBase exte
         }
         hpackEncoder.encode(mimeHeaders, headersPayload);
 
-        headersPayload.flip();
+        ((Buffer)headersPayload).flip();
 
         ByteUtil.setThreeBytes(frameHeader, 0, headersPayload.limit());
         frameHeader[3] = FrameType.HEADERS.getIdByte();
@@ -283,7 +284,7 @@ public abstract class Http2TestBase exte
         }
         hpackEncoder.encode(mimeHeaders, headersPayload);
 
-        headersPayload.flip();
+        ((Buffer)headersPayload).flip();
 
         ByteUtil.setThreeBytes(frameHeader, 0, headersPayload.limit());
         frameHeader[3] = FrameType.CONTINUATION.getIdByte();
@@ -373,7 +374,7 @@ public abstract class Http2TestBase exte
         }
         hpackEncoder.encode(headers, headersPayload);
 
-        headersPayload.flip();
+        ((Buffer)headersPayload).flip();
 
         ByteUtil.setThreeBytes(headersFrameHeader, 0, headersPayload.limit());
         headersFrameHeader[3] = FrameType.HEADERS.getIdByte();
@@ -385,18 +386,18 @@ public abstract class Http2TestBase exte
         // Data
         if (padding != null) {
             dataPayload.put((byte) (padding.length & 0xFF));
-            dataPayload.limit(dataPayload.capacity() - padding.length);
+            ((Buffer)dataPayload).limit(dataPayload.capacity() - padding.length);
         }
 
         while (dataPayload.hasRemaining()) {
             dataPayload.put((byte) 'x');
         }
         if (padding != null && padding.length > 0) {
-            dataPayload.limit(dataPayload.capacity());
+            ((Buffer)dataPayload).limit(dataPayload.capacity());
             dataPayload.put(padding);
         }
 
-        dataPayload.flip();
+        ((Buffer)dataPayload).flip();
 
         // Size
         ByteUtil.setThreeBytes(dataFrameHeader, 0, dataPayload.limit());
@@ -418,7 +419,7 @@ public abstract class Http2TestBase exte
             trailerHeaders.addValue(TRAILER_HEADER_NAME).setString(TRAILER_HEADER_VALUE);
             hpackEncoder.encode(trailerHeaders, trailersPayload);
 
-            trailersPayload.flip();
+            ((Buffer)trailersPayload).flip();
 
             ByteUtil.setThreeBytes(trailersFrameHeader, 0, trailersPayload.limit());
             trailersFrameHeader[3] = FrameType.HEADERS.getIdByte();
@@ -1018,7 +1019,7 @@ public abstract class Http2TestBase exte
             if (bodyBuffer != null) {
                 if (bodyBuffer.limit() > 0) {
                     trace.append(lastStreamId + "-Body-");
-                    bodyBuffer.flip();
+                    ((Buffer)bodyBuffer).flip();
                     while (bodyBuffer.hasRemaining()) {
                         trace.append((char) bodyBuffer.get());
                     }
Index: apache-tomcat-9.0.33-src/test/org/apache/coyote/http2/TestHpack.java
===================================================================
--- apache-tomcat-9.0.33-src.orig/test/org/apache/coyote/http2/TestHpack.java
+++ apache-tomcat-9.0.33-src/test/org/apache/coyote/http2/TestHpack.java
@@ -16,6 +16,7 @@
  */
 package org.apache.coyote.http2;
 
+import java.nio.Buffer;
 import java.nio.ByteBuffer;
 
 import org.junit.Assert;
@@ -34,13 +35,13 @@ public class TestHpack {
         ByteBuffer output = ByteBuffer.allocate(512);
         HpackEncoder encoder = new HpackEncoder();
         encoder.encode(headers, output);
-        output.flip();
+        ((Buffer)output).flip();
         // Size is supposed to be 33 without huffman, or 27 with it
         // TODO: use the HpackHeaderFunction to enable huffman predictably
         Assert.assertEquals(27, output.remaining());
-        output.clear();
+        ((Buffer)output).clear();
         encoder.encode(headers, output);
-        output.flip();
+        ((Buffer)output).flip();
         // Size is now 3 after using the table
         Assert.assertEquals(3, output.remaining());
     }
@@ -54,15 +55,15 @@ public class TestHpack {
         ByteBuffer output = ByteBuffer.allocate(512);
         HpackEncoder encoder = new HpackEncoder();
         encoder.encode(headers, output);
-        output.flip();
+        ((Buffer)output).flip();
         MimeHeaders headers2 = new MimeHeaders();
         HpackDecoder decoder = new HpackDecoder();
         decoder.setHeaderEmitter(new HeadersListener(headers2));
         decoder.decode(output);
         // Redo (table is supposed to be updated)
-        output.clear();
+        ((Buffer)output).clear();
         encoder.encode(headers, output);
-        output.flip();
+        ((Buffer)output).flip();
         headers2.recycle();
         Assert.assertEquals(3, output.remaining());
         // Check that the decoder is using the table right
@@ -120,7 +121,7 @@ public class TestHpack {
         // by another byte
         output.array()[7] = (byte) -122;
         output.put((byte) -1);
-        output.flip();
+        ((Buffer)output).flip();
         MimeHeaders headers2 = new MimeHeaders();
         HpackDecoder decoder = new HpackDecoder();
         decoder.setHeaderEmitter(new HeadersListener(headers2));
@@ -136,7 +137,7 @@ public class TestHpack {
         ByteBuffer output = ByteBuffer.allocate(512);
         HpackEncoder encoder = new HpackEncoder();
         encoder.encode(headers, output);
-        output.flip();
+        ((Buffer)output).flip();
         MimeHeaders headers2 = new MimeHeaders();
         HpackDecoder decoder = new HpackDecoder();
         decoder.setHeaderEmitter(new HeadersListener(headers2));
Index: apache-tomcat-9.0.33-src/test/org/apache/coyote/http2/TestHttp2Limits.java
===================================================================
--- apache-tomcat-9.0.33-src.orig/test/org/apache/coyote/http2/TestHttp2Limits.java
+++ apache-tomcat-9.0.33-src/test/org/apache/coyote/http2/TestHttp2Limits.java
@@ -17,6 +17,7 @@
 package org.apache.coyote.http2;
 
 import java.io.IOException;
+import java.nio.Buffer;
 import java.nio.ByteBuffer;
 import java.util.ArrayList;
 import java.util.List;
@@ -290,7 +291,7 @@ public class TestHttp2Limits extends Htt
         if (state != State.COMPLETE) {
             throw new Exception("Unable to build headers");
         }
-        headersPayload.flip();
+        ((Buffer)headersPayload).flip();
 
         log.debug("Headers payload generated of size [" + headersPayload.limit() + "]");
     }
Index: apache-tomcat-9.0.33-src/test/org/apache/coyote/http2/TestHttp2Section_8_1.java
===================================================================
--- apache-tomcat-9.0.33-src.orig/test/org/apache/coyote/http2/TestHttp2Section_8_1.java
+++ apache-tomcat-9.0.33-src/test/org/apache/coyote/http2/TestHttp2Section_8_1.java
@@ -16,6 +16,7 @@
  */
 package org.apache.coyote.http2;
 
+import java.nio.Buffer;
 import java.nio.ByteBuffer;
 import java.util.ArrayList;
 import java.util.List;
@@ -186,7 +187,7 @@ public class TestHttp2Section_8_1 extend
 
         headers.clear();
         headers.add(new Header(":authority", "localhost:" + getPort()));
-        headersPayload.clear();
+        ((Buffer)headersPayload).clear();
 
         buildSimpleGetRequestPart2(headersFrameHeader, headersPayload, headers , 3);
 
Index: apache-tomcat-9.0.33-src/test/org/apache/tomcat/util/buf/TestUtf8.java
===================================================================
--- apache-tomcat-9.0.33-src.orig/test/org/apache/tomcat/util/buf/TestUtf8.java
+++ apache-tomcat-9.0.33-src/test/org/apache/tomcat/util/buf/TestUtf8.java
@@ -16,6 +16,7 @@
  */
 package org.apache.tomcat.util.buf;
 
+import java.nio.Buffer;
 import java.nio.ByteBuffer;
 import java.nio.CharBuffer;
 import java.nio.charset.CharsetDecoder;
@@ -579,7 +580,7 @@ public class TestUtf8 {
         // an invalid sequence has been provided
         for (int i = 0; i < len; i++) {
             bb.put((byte) testCase.input[i]);
-            bb.flip();
+            ((Buffer)bb).flip();
             CoderResult cr = decoder.decode(bb, cb, false);
             if (cr.isError()) {
                 int expected =  testCase.invalidIndex;
@@ -604,11 +605,11 @@ public class TestUtf8 {
         decoder.onUnmappableCharacter(CodingErrorAction.REPLACE);
 
         // Add each byte one at a time.
-        bb.clear();
-        cb.clear();
+        ((Buffer)bb).clear();
+        ((Buffer)cb).clear();
         for (int i = 0; i < len; i++) {
             bb.put((byte) testCase.input[i]);
-            bb.flip();
+            ((Buffer)bb).flip();
             CoderResult cr = decoder.decode(bb, cb, false);
             if (cr.isError()) {
                 Assert.fail(testCase.description);
@@ -617,12 +618,12 @@ public class TestUtf8 {
         }
         // For incomplete sequences at the end of the input need to tell
         // the decoder the input has ended
-        bb.flip();
+        ((Buffer)bb).flip();
         CoderResult cr = decoder.decode(bb, cb, true);
         if (cr.isError()) {
             Assert.fail(testCase.description);
         }
-        cb.flip();
+        ((Buffer)cb).flip();
 
         String expected = testCase.outputReplaced;
         if ((flags & REPLACE_SWALLOWS_TRAILER) != 0) {
Index: apache-tomcat-9.0.33-src/test/org/apache/tomcat/websocket/pojo/TestEncodingDecoding.java
===================================================================
--- apache-tomcat-9.0.33-src.orig/test/org/apache/tomcat/websocket/pojo/TestEncodingDecoding.java
+++ apache-tomcat-9.0.33-src/test/org/apache/tomcat/websocket/pojo/TestEncodingDecoding.java
@@ -18,6 +18,7 @@ package org.apache.tomcat.websocket.pojo
 
 import java.io.IOException;
 import java.net.URI;
+import java.nio.Buffer;
 import java.nio.ByteBuffer;
 import java.util.ArrayList;
 import java.util.Collections;
@@ -604,7 +605,7 @@ public class TestEncodingDecoding extend
             reply.put((byte) 0x12);
             reply.put((byte) 0x34);
             reply.put(data);
-            reply.flip();
+            ((Buffer)reply).flip();
             return reply;
         }
     }
